/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|*  * MSP430 Disassembler                                                     *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/


#include "llvm/MC/MCInst.h"
#include "llvm/MC/MCSubtargetInfo.h"
#include "llvm/Support/DataTypes.h"
#include "llvm/Support/Debug.h"
#include "llvm/Support/LEB128.h"
#include "llvm/Support/raw_ostream.h"
#include "llvm/TargetParser/SubtargetFeature.h"
#include <assert.h>

namespace {

// Helper functions for extracting fields from encoded instructions.
// InsnType must either be integral or an APInt-like object that must:
// * be default-constructible and copy-constructible
// * be constructible from an APInt (this can be private)
// * Support insertBits(bits, startBit, numBits)
// * Support extractBitsAsZExtValue(numBits, startBit)
// * Support the ~, &, ==, and != operators with other objects of the same type
// * Support the != and bitwise & with uint64_t
// * Support put (<<) to raw_ostream&
template <typename InsnType>
#if defined(_MSC_VER) && !defined(__clang__)
__declspec(noinline)
#endif
static std::enable_if_t<std::is_integral<InsnType>::value, InsnType>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  assert(startBit + numBits <= 64 && "Cannot support >64-bit extractions!");
  assert(startBit + numBits <= (sizeof(InsnType) * 8) &&
         "Instruction field out of bounds!");
  InsnType fieldMask;
  if (numBits == sizeof(InsnType) * 8)
    fieldMask = (InsnType)(-1LL);
  else
    fieldMask = (((InsnType)1 << numBits) - 1) << startBit;
  return (insn & fieldMask) >> startBit;
}

template <typename InsnType>
static std::enable_if_t<!std::is_integral<InsnType>::value, uint64_t>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  return insn.extractBitsAsZExtValue(numBits, startBit);
}

// Helper function for inserting bits extracted from an encoded instruction into
// a field.
template <typename InsnType>
static void insertBits(InsnType &field, InsnType bits, unsigned startBit,
                       unsigned numBits) {
  if constexpr (std::is_integral<InsnType>::value) {
    assert(startBit + numBits <= sizeof field * 8);
    field |= (InsnType)bits << startBit;
  } else {
    field.insertBits(bits, startBit, numBits);
  }
}

static bool Check(DecodeStatus &Out, DecodeStatus In) {
  Out = static_cast<DecodeStatus>(Out & In);
  return Out != MCDisassembler::Fail;
}

static const uint8_t DecoderTable16[] = {
/* 0 */       MCD::OPC_ExtractField, 13, 3,  // Inst{15-13} ...
/* 3 */       MCD::OPC_FilterValue, 0, 10, 1, // Skip to: 273
/* 7 */       MCD::OPC_ExtractField, 6, 7,  // Inst{12-6} ...
/* 10 */      MCD::OPC_FilterValue, 64, 27, 0, // Skip to: 41
/* 14 */      MCD::OPC_ExtractField, 4, 2,  // Inst{5-4} ...
/* 17 */      MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 25
/* 21 */      MCD::OPC_Decode, 173, 4, 0, // Opcode: RRC16r
/* 25 */      MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 33
/* 29 */      MCD::OPC_Decode, 171, 4, 1, // Opcode: RRC16n
/* 33 */      MCD::OPC_FilterValue, 3, 254, 0, // Skip to: 291
/* 37 */      MCD::OPC_Decode, 172, 4, 1, // Opcode: RRC16p
/* 41 */      MCD::OPC_FilterValue, 65, 27, 0, // Skip to: 72
/* 45 */      MCD::OPC_ExtractField, 4, 2,  // Inst{5-4} ...
/* 48 */      MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 56
/* 52 */      MCD::OPC_Decode, 177, 4, 2, // Opcode: RRC8r
/* 56 */      MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 64
/* 60 */      MCD::OPC_Decode, 175, 4, 1, // Opcode: RRC8n
/* 64 */      MCD::OPC_FilterValue, 3, 223, 0, // Skip to: 291
/* 68 */      MCD::OPC_Decode, 176, 4, 1, // Opcode: RRC8p
/* 72 */      MCD::OPC_FilterValue, 66, 27, 0, // Skip to: 103
/* 76 */      MCD::OPC_ExtractField, 4, 2,  // Inst{5-4} ...
/* 79 */      MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 87
/* 83 */      MCD::OPC_Decode, 235, 4, 0, // Opcode: SWPB16r
/* 87 */      MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 95
/* 91 */      MCD::OPC_Decode, 233, 4, 1, // Opcode: SWPB16n
/* 95 */      MCD::OPC_FilterValue, 3, 192, 0, // Skip to: 291
/* 99 */      MCD::OPC_Decode, 234, 4, 1, // Opcode: SWPB16p
/* 103 */     MCD::OPC_FilterValue, 68, 27, 0, // Skip to: 134
/* 107 */     MCD::OPC_ExtractField, 4, 2,  // Inst{5-4} ...
/* 110 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 118
/* 114 */     MCD::OPC_Decode, 165, 4, 0, // Opcode: RRA16r
/* 118 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 126
/* 122 */     MCD::OPC_Decode, 163, 4, 1, // Opcode: RRA16n
/* 126 */     MCD::OPC_FilterValue, 3, 161, 0, // Skip to: 291
/* 130 */     MCD::OPC_Decode, 164, 4, 1, // Opcode: RRA16p
/* 134 */     MCD::OPC_FilterValue, 69, 27, 0, // Skip to: 165
/* 138 */     MCD::OPC_ExtractField, 4, 2,  // Inst{5-4} ...
/* 141 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 149
/* 145 */     MCD::OPC_Decode, 169, 4, 2, // Opcode: RRA8r
/* 149 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 157
/* 153 */     MCD::OPC_Decode, 167, 4, 1, // Opcode: RRA8n
/* 157 */     MCD::OPC_FilterValue, 3, 130, 0, // Skip to: 291
/* 161 */     MCD::OPC_Decode, 168, 4, 1, // Opcode: RRA8p
/* 165 */     MCD::OPC_FilterValue, 70, 27, 0, // Skip to: 196
/* 169 */     MCD::OPC_ExtractField, 4, 2,  // Inst{5-4} ...
/* 172 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 180
/* 176 */     MCD::OPC_Decode, 183, 4, 0, // Opcode: SEXT16r
/* 180 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 188
/* 184 */     MCD::OPC_Decode, 181, 4, 1, // Opcode: SEXT16n
/* 188 */     MCD::OPC_FilterValue, 3, 99, 0, // Skip to: 291
/* 192 */     MCD::OPC_Decode, 182, 4, 1, // Opcode: SEXT16p
/* 196 */     MCD::OPC_FilterValue, 72, 14, 0, // Skip to: 214
/* 200 */     MCD::OPC_CheckField, 4, 2, 0, 4, 0, // Skip to: 210
/* 206 */     MCD::OPC_Decode, 158, 4, 1, // Opcode: PUSH16r
/* 210 */     MCD::OPC_Decode, 156, 4, 3, // Opcode: PUSH16c
/* 214 */     MCD::OPC_FilterValue, 73, 10, 0, // Skip to: 228
/* 218 */     MCD::OPC_CheckField, 4, 2, 0, 67, 0, // Skip to: 291
/* 224 */     MCD::OPC_Decode, 159, 4, 4, // Opcode: PUSH8r
/* 228 */     MCD::OPC_FilterValue, 74, 27, 0, // Skip to: 259
/* 232 */     MCD::OPC_ExtractField, 4, 2,  // Inst{5-4} ...
/* 235 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 243
/* 239 */     MCD::OPC_Decode, 208, 3, 1, // Opcode: CALLr
/* 243 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 251
/* 247 */     MCD::OPC_Decode, 206, 3, 1, // Opcode: CALLn
/* 251 */     MCD::OPC_FilterValue, 3, 36, 0, // Skip to: 291
/* 255 */     MCD::OPC_Decode, 207, 3, 1, // Opcode: CALLp
/* 259 */     MCD::OPC_FilterValue, 76, 28, 0, // Skip to: 291
/* 263 */     MCD::OPC_CheckField, 0, 6, 0, 22, 0, // Skip to: 291
/* 269 */     MCD::OPC_Decode, 161, 4, 5, // Opcode: RETI
/* 273 */     MCD::OPC_FilterValue, 1, 14, 0, // Skip to: 291
/* 277 */     MCD::OPC_CheckField, 10, 3, 7, 4, 0, // Skip to: 287
/* 283 */     MCD::OPC_Decode, 130, 4, 6, // Opcode: JMP
/* 287 */     MCD::OPC_Decode, 129, 4, 7, // Opcode: JCC
/* 291 */     MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTable32[] = {
/* 0 */       MCD::OPC_ExtractField, 4, 12,  // Inst{15-4} ...
/* 3 */       MCD::OPC_FilterValue, 129, 2, 4, 0, // Skip to: 12
/* 8 */       MCD::OPC_Decode, 170, 4, 8, // Opcode: RRC16m
/* 12 */      MCD::OPC_FilterValue, 133, 2, 4, 0, // Skip to: 21
/* 17 */      MCD::OPC_Decode, 174, 4, 8, // Opcode: RRC8m
/* 21 */      MCD::OPC_FilterValue, 137, 2, 4, 0, // Skip to: 30
/* 26 */      MCD::OPC_Decode, 232, 4, 8, // Opcode: SWPB16m
/* 30 */      MCD::OPC_FilterValue, 145, 2, 4, 0, // Skip to: 39
/* 35 */      MCD::OPC_Decode, 162, 4, 8, // Opcode: RRA16m
/* 39 */      MCD::OPC_FilterValue, 149, 2, 4, 0, // Skip to: 48
/* 44 */      MCD::OPC_Decode, 166, 4, 8, // Opcode: RRA8m
/* 48 */      MCD::OPC_FilterValue, 153, 2, 4, 0, // Skip to: 57
/* 53 */      MCD::OPC_Decode, 180, 4, 8, // Opcode: SEXT16m
/* 57 */      MCD::OPC_FilterValue, 163, 2, 10, 0, // Skip to: 72
/* 62 */      MCD::OPC_CheckField, 0, 4, 0, 28, 0, // Skip to: 96
/* 68 */      MCD::OPC_Decode, 157, 4, 9, // Opcode: PUSH16i
/* 72 */      MCD::OPC_FilterValue, 169, 2, 4, 0, // Skip to: 81
/* 77 */      MCD::OPC_Decode, 205, 3, 8, // Opcode: CALLm
/* 81 */      MCD::OPC_FilterValue, 171, 2, 10, 0, // Skip to: 96
/* 86 */      MCD::OPC_CheckField, 0, 4, 0, 4, 0, // Skip to: 96
/* 92 */      MCD::OPC_Decode, 204, 3, 9, // Opcode: CALLi
/* 96 */      MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableAlpha16[] = {
/* 0 */       MCD::OPC_ExtractField, 12, 4,  // Inst{15-12} ...
/* 3 */       MCD::OPC_FilterValue, 4, 29, 0, // Skip to: 36
/* 7 */       MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 10 */      MCD::OPC_FilterValue, 0, 14, 0, // Skip to: 28
/* 14 */      MCD::OPC_CheckField, 0, 4, 0, 4, 0, // Skip to: 24
/* 20 */      MCD::OPC_Decode, 203, 3, 10, // Opcode: Br
/* 24 */      MCD::OPC_Decode, 141, 4, 11, // Opcode: MOV16rr
/* 28 */      MCD::OPC_FilterValue, 4, 1, 1, // Skip to: 289
/* 32 */      MCD::OPC_Decode, 152, 4, 12, // Opcode: MOV8rr
/* 36 */      MCD::OPC_FilterValue, 5, 19, 0, // Skip to: 59
/* 40 */      MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 43 */      MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 51
/* 47 */      MCD::OPC_Decode, 193, 2, 13, // Opcode: ADD16rr
/* 51 */      MCD::OPC_FilterValue, 4, 234, 0, // Skip to: 289
/* 55 */      MCD::OPC_Decode, 205, 2, 14, // Opcode: ADD8rr
/* 59 */      MCD::OPC_FilterValue, 6, 19, 0, // Skip to: 82
/* 63 */      MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 66 */      MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 74
/* 70 */      MCD::OPC_Decode, 217, 2, 13, // Opcode: ADDC16rr
/* 74 */      MCD::OPC_FilterValue, 4, 211, 0, // Skip to: 289
/* 78 */      MCD::OPC_Decode, 229, 2, 14, // Opcode: ADDC8rr
/* 82 */      MCD::OPC_FilterValue, 7, 19, 0, // Skip to: 105
/* 86 */      MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 89 */      MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 97
/* 93 */      MCD::OPC_Decode, 219, 4, 13, // Opcode: SUBC16rr
/* 97 */      MCD::OPC_FilterValue, 4, 188, 0, // Skip to: 289
/* 101 */     MCD::OPC_Decode, 231, 4, 14, // Opcode: SUBC8rr
/* 105 */     MCD::OPC_FilterValue, 8, 19, 0, // Skip to: 128
/* 109 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 112 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 120
/* 116 */     MCD::OPC_Decode, 195, 4, 13, // Opcode: SUB16rr
/* 120 */     MCD::OPC_FilterValue, 4, 165, 0, // Skip to: 289
/* 124 */     MCD::OPC_Decode, 207, 4, 14, // Opcode: SUB8rr
/* 128 */     MCD::OPC_FilterValue, 9, 19, 0, // Skip to: 151
/* 132 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 135 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 143
/* 139 */     MCD::OPC_Decode, 220, 3, 11, // Opcode: CMP16rr
/* 143 */     MCD::OPC_FilterValue, 4, 142, 0, // Skip to: 289
/* 147 */     MCD::OPC_Decode, 232, 3, 12, // Opcode: CMP8rr
/* 151 */     MCD::OPC_FilterValue, 10, 19, 0, // Skip to: 174
/* 155 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 158 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 166
/* 162 */     MCD::OPC_Decode, 244, 3, 13, // Opcode: DADD16rr
/* 166 */     MCD::OPC_FilterValue, 4, 119, 0, // Skip to: 289
/* 170 */     MCD::OPC_Decode, 128, 4, 14, // Opcode: DADD8rr
/* 174 */     MCD::OPC_FilterValue, 11, 19, 0, // Skip to: 197
/* 178 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 181 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 189
/* 185 */     MCD::OPC_Decode, 188, 3, 11, // Opcode: BIT16rr
/* 189 */     MCD::OPC_FilterValue, 4, 96, 0, // Skip to: 289
/* 193 */     MCD::OPC_Decode, 200, 3, 12, // Opcode: BIT8rr
/* 197 */     MCD::OPC_FilterValue, 12, 19, 0, // Skip to: 220
/* 201 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 204 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 212
/* 208 */     MCD::OPC_Decode, 140, 3, 13, // Opcode: BIC16rr
/* 212 */     MCD::OPC_FilterValue, 4, 73, 0, // Skip to: 289
/* 216 */     MCD::OPC_Decode, 152, 3, 14, // Opcode: BIC8rr
/* 220 */     MCD::OPC_FilterValue, 13, 19, 0, // Skip to: 243
/* 224 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 227 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 235
/* 231 */     MCD::OPC_Decode, 164, 3, 13, // Opcode: BIS16rr
/* 235 */     MCD::OPC_FilterValue, 4, 50, 0, // Skip to: 289
/* 239 */     MCD::OPC_Decode, 176, 3, 14, // Opcode: BIS8rr
/* 243 */     MCD::OPC_FilterValue, 14, 19, 0, // Skip to: 266
/* 247 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 250 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 258
/* 254 */     MCD::OPC_Decode, 255, 4, 13, // Opcode: XOR16rr
/* 258 */     MCD::OPC_FilterValue, 4, 27, 0, // Skip to: 289
/* 262 */     MCD::OPC_Decode, 139, 5, 14, // Opcode: XOR8rr
/* 266 */     MCD::OPC_FilterValue, 15, 19, 0, // Skip to: 289
/* 270 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 273 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 281
/* 277 */     MCD::OPC_Decode, 244, 2, 13, // Opcode: AND16rr
/* 281 */     MCD::OPC_FilterValue, 4, 4, 0, // Skip to: 289
/* 285 */     MCD::OPC_Decode, 128, 3, 14, // Opcode: AND8rr
/* 289 */     MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableAlpha32[] = {
/* 0 */       MCD::OPC_ExtractField, 12, 4,  // Inst{15-12} ...
/* 3 */       MCD::OPC_FilterValue, 4, 19, 0, // Skip to: 26
/* 7 */       MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 10 */      MCD::OPC_FilterValue, 8, 4, 0, // Skip to: 18
/* 14 */      MCD::OPC_Decode, 135, 4, 15, // Opcode: MOV16mr
/* 18 */      MCD::OPC_FilterValue, 12, 1, 1, // Skip to: 279
/* 22 */      MCD::OPC_Decode, 146, 4, 16, // Opcode: MOV8mr
/* 26 */      MCD::OPC_FilterValue, 5, 19, 0, // Skip to: 49
/* 30 */      MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 33 */      MCD::OPC_FilterValue, 8, 4, 0, // Skip to: 41
/* 37 */      MCD::OPC_Decode, 187, 2, 15, // Opcode: ADD16mr
/* 41 */      MCD::OPC_FilterValue, 12, 234, 0, // Skip to: 279
/* 45 */      MCD::OPC_Decode, 199, 2, 16, // Opcode: ADD8mr
/* 49 */      MCD::OPC_FilterValue, 6, 19, 0, // Skip to: 72
/* 53 */      MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 56 */      MCD::OPC_FilterValue, 8, 4, 0, // Skip to: 64
/* 60 */      MCD::OPC_Decode, 211, 2, 15, // Opcode: ADDC16mr
/* 64 */      MCD::OPC_FilterValue, 12, 211, 0, // Skip to: 279
/* 68 */      MCD::OPC_Decode, 223, 2, 16, // Opcode: ADDC8mr
/* 72 */      MCD::OPC_FilterValue, 7, 19, 0, // Skip to: 95
/* 76 */      MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 79 */      MCD::OPC_FilterValue, 8, 4, 0, // Skip to: 87
/* 83 */      MCD::OPC_Decode, 213, 4, 15, // Opcode: SUBC16mr
/* 87 */      MCD::OPC_FilterValue, 12, 188, 0, // Skip to: 279
/* 91 */      MCD::OPC_Decode, 225, 4, 16, // Opcode: SUBC8mr
/* 95 */      MCD::OPC_FilterValue, 8, 19, 0, // Skip to: 118
/* 99 */      MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 102 */     MCD::OPC_FilterValue, 8, 4, 0, // Skip to: 110
/* 106 */     MCD::OPC_Decode, 189, 4, 15, // Opcode: SUB16mr
/* 110 */     MCD::OPC_FilterValue, 12, 165, 0, // Skip to: 279
/* 114 */     MCD::OPC_Decode, 201, 4, 16, // Opcode: SUB8mr
/* 118 */     MCD::OPC_FilterValue, 9, 19, 0, // Skip to: 141
/* 122 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 125 */     MCD::OPC_FilterValue, 8, 4, 0, // Skip to: 133
/* 129 */     MCD::OPC_Decode, 214, 3, 15, // Opcode: CMP16mr
/* 133 */     MCD::OPC_FilterValue, 12, 142, 0, // Skip to: 279
/* 137 */     MCD::OPC_Decode, 226, 3, 16, // Opcode: CMP8mr
/* 141 */     MCD::OPC_FilterValue, 10, 19, 0, // Skip to: 164
/* 145 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 148 */     MCD::OPC_FilterValue, 8, 4, 0, // Skip to: 156
/* 152 */     MCD::OPC_Decode, 238, 3, 15, // Opcode: DADD16mr
/* 156 */     MCD::OPC_FilterValue, 12, 119, 0, // Skip to: 279
/* 160 */     MCD::OPC_Decode, 250, 3, 16, // Opcode: DADD8mr
/* 164 */     MCD::OPC_FilterValue, 11, 19, 0, // Skip to: 187
/* 168 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 171 */     MCD::OPC_FilterValue, 8, 4, 0, // Skip to: 179
/* 175 */     MCD::OPC_Decode, 182, 3, 15, // Opcode: BIT16mr
/* 179 */     MCD::OPC_FilterValue, 12, 96, 0, // Skip to: 279
/* 183 */     MCD::OPC_Decode, 194, 3, 16, // Opcode: BIT8mr
/* 187 */     MCD::OPC_FilterValue, 12, 19, 0, // Skip to: 210
/* 191 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 194 */     MCD::OPC_FilterValue, 8, 4, 0, // Skip to: 202
/* 198 */     MCD::OPC_Decode, 134, 3, 15, // Opcode: BIC16mr
/* 202 */     MCD::OPC_FilterValue, 12, 73, 0, // Skip to: 279
/* 206 */     MCD::OPC_Decode, 146, 3, 16, // Opcode: BIC8mr
/* 210 */     MCD::OPC_FilterValue, 13, 19, 0, // Skip to: 233
/* 214 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 217 */     MCD::OPC_FilterValue, 8, 4, 0, // Skip to: 225
/* 221 */     MCD::OPC_Decode, 158, 3, 15, // Opcode: BIS16mr
/* 225 */     MCD::OPC_FilterValue, 12, 50, 0, // Skip to: 279
/* 229 */     MCD::OPC_Decode, 170, 3, 16, // Opcode: BIS8mr
/* 233 */     MCD::OPC_FilterValue, 14, 19, 0, // Skip to: 256
/* 237 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 240 */     MCD::OPC_FilterValue, 8, 4, 0, // Skip to: 248
/* 244 */     MCD::OPC_Decode, 249, 4, 15, // Opcode: XOR16mr
/* 248 */     MCD::OPC_FilterValue, 12, 27, 0, // Skip to: 279
/* 252 */     MCD::OPC_Decode, 133, 5, 16, // Opcode: XOR8mr
/* 256 */     MCD::OPC_FilterValue, 15, 19, 0, // Skip to: 279
/* 260 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 263 */     MCD::OPC_FilterValue, 8, 4, 0, // Skip to: 271
/* 267 */     MCD::OPC_Decode, 238, 2, 15, // Opcode: AND16mr
/* 271 */     MCD::OPC_FilterValue, 12, 4, 0, // Skip to: 279
/* 275 */     MCD::OPC_Decode, 250, 2, 16, // Opcode: AND8mr
/* 279 */     MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableBeta16[] = {
/* 0 */       MCD::OPC_ExtractField, 12, 4,  // Inst{15-12} ...
/* 3 */       MCD::OPC_FilterValue, 4, 19, 0, // Skip to: 26
/* 7 */       MCD::OPC_ExtractField, 6, 2,  // Inst{7-6} ...
/* 10 */      MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 18
/* 14 */      MCD::OPC_Decode, 136, 4, 17, // Opcode: MOV16rc
/* 18 */      MCD::OPC_FilterValue, 1, 1, 1, // Skip to: 279
/* 22 */      MCD::OPC_Decode, 147, 4, 18, // Opcode: MOV8rc
/* 26 */      MCD::OPC_FilterValue, 5, 19, 0, // Skip to: 49
/* 30 */      MCD::OPC_ExtractField, 6, 2,  // Inst{7-6} ...
/* 33 */      MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 41
/* 37 */      MCD::OPC_Decode, 188, 2, 19, // Opcode: ADD16rc
/* 41 */      MCD::OPC_FilterValue, 1, 234, 0, // Skip to: 279
/* 45 */      MCD::OPC_Decode, 200, 2, 20, // Opcode: ADD8rc
/* 49 */      MCD::OPC_FilterValue, 6, 19, 0, // Skip to: 72
/* 53 */      MCD::OPC_ExtractField, 6, 2,  // Inst{7-6} ...
/* 56 */      MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 64
/* 60 */      MCD::OPC_Decode, 212, 2, 19, // Opcode: ADDC16rc
/* 64 */      MCD::OPC_FilterValue, 1, 211, 0, // Skip to: 279
/* 68 */      MCD::OPC_Decode, 224, 2, 20, // Opcode: ADDC8rc
/* 72 */      MCD::OPC_FilterValue, 7, 19, 0, // Skip to: 95
/* 76 */      MCD::OPC_ExtractField, 6, 2,  // Inst{7-6} ...
/* 79 */      MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 87
/* 83 */      MCD::OPC_Decode, 214, 4, 19, // Opcode: SUBC16rc
/* 87 */      MCD::OPC_FilterValue, 1, 188, 0, // Skip to: 279
/* 91 */      MCD::OPC_Decode, 226, 4, 20, // Opcode: SUBC8rc
/* 95 */      MCD::OPC_FilterValue, 8, 19, 0, // Skip to: 118
/* 99 */      MCD::OPC_ExtractField, 6, 2,  // Inst{7-6} ...
/* 102 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 110
/* 106 */     MCD::OPC_Decode, 190, 4, 19, // Opcode: SUB16rc
/* 110 */     MCD::OPC_FilterValue, 1, 165, 0, // Skip to: 279
/* 114 */     MCD::OPC_Decode, 202, 4, 20, // Opcode: SUB8rc
/* 118 */     MCD::OPC_FilterValue, 9, 19, 0, // Skip to: 141
/* 122 */     MCD::OPC_ExtractField, 6, 2,  // Inst{7-6} ...
/* 125 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 133
/* 129 */     MCD::OPC_Decode, 215, 3, 17, // Opcode: CMP16rc
/* 133 */     MCD::OPC_FilterValue, 1, 142, 0, // Skip to: 279
/* 137 */     MCD::OPC_Decode, 227, 3, 18, // Opcode: CMP8rc
/* 141 */     MCD::OPC_FilterValue, 10, 19, 0, // Skip to: 164
/* 145 */     MCD::OPC_ExtractField, 6, 2,  // Inst{7-6} ...
/* 148 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 156
/* 152 */     MCD::OPC_Decode, 239, 3, 19, // Opcode: DADD16rc
/* 156 */     MCD::OPC_FilterValue, 1, 119, 0, // Skip to: 279
/* 160 */     MCD::OPC_Decode, 251, 3, 20, // Opcode: DADD8rc
/* 164 */     MCD::OPC_FilterValue, 11, 19, 0, // Skip to: 187
/* 168 */     MCD::OPC_ExtractField, 6, 2,  // Inst{7-6} ...
/* 171 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 179
/* 175 */     MCD::OPC_Decode, 183, 3, 17, // Opcode: BIT16rc
/* 179 */     MCD::OPC_FilterValue, 1, 96, 0, // Skip to: 279
/* 183 */     MCD::OPC_Decode, 195, 3, 18, // Opcode: BIT8rc
/* 187 */     MCD::OPC_FilterValue, 12, 19, 0, // Skip to: 210
/* 191 */     MCD::OPC_ExtractField, 6, 2,  // Inst{7-6} ...
/* 194 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 202
/* 198 */     MCD::OPC_Decode, 135, 3, 19, // Opcode: BIC16rc
/* 202 */     MCD::OPC_FilterValue, 1, 73, 0, // Skip to: 279
/* 206 */     MCD::OPC_Decode, 147, 3, 20, // Opcode: BIC8rc
/* 210 */     MCD::OPC_FilterValue, 13, 19, 0, // Skip to: 233
/* 214 */     MCD::OPC_ExtractField, 6, 2,  // Inst{7-6} ...
/* 217 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 225
/* 221 */     MCD::OPC_Decode, 159, 3, 19, // Opcode: BIS16rc
/* 225 */     MCD::OPC_FilterValue, 1, 50, 0, // Skip to: 279
/* 229 */     MCD::OPC_Decode, 171, 3, 20, // Opcode: BIS8rc
/* 233 */     MCD::OPC_FilterValue, 14, 19, 0, // Skip to: 256
/* 237 */     MCD::OPC_ExtractField, 6, 2,  // Inst{7-6} ...
/* 240 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 248
/* 244 */     MCD::OPC_Decode, 250, 4, 19, // Opcode: XOR16rc
/* 248 */     MCD::OPC_FilterValue, 1, 27, 0, // Skip to: 279
/* 252 */     MCD::OPC_Decode, 134, 5, 20, // Opcode: XOR8rc
/* 256 */     MCD::OPC_FilterValue, 15, 19, 0, // Skip to: 279
/* 260 */     MCD::OPC_ExtractField, 6, 2,  // Inst{7-6} ...
/* 263 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 271
/* 267 */     MCD::OPC_Decode, 239, 2, 19, // Opcode: AND16rc
/* 271 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 279
/* 275 */     MCD::OPC_Decode, 251, 2, 20, // Opcode: AND8rc
/* 279 */     MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableBeta32[] = {
/* 0 */       MCD::OPC_ExtractField, 12, 4,  // Inst{15-12} ...
/* 3 */       MCD::OPC_FilterValue, 4, 19, 0, // Skip to: 26
/* 7 */       MCD::OPC_ExtractField, 6, 2,  // Inst{7-6} ...
/* 10 */      MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 18
/* 14 */      MCD::OPC_Decode, 131, 4, 21, // Opcode: MOV16mc
/* 18 */      MCD::OPC_FilterValue, 3, 1, 1, // Skip to: 279
/* 22 */      MCD::OPC_Decode, 142, 4, 21, // Opcode: MOV8mc
/* 26 */      MCD::OPC_FilterValue, 5, 19, 0, // Skip to: 49
/* 30 */      MCD::OPC_ExtractField, 6, 2,  // Inst{7-6} ...
/* 33 */      MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 41
/* 37 */      MCD::OPC_Decode, 182, 2, 21, // Opcode: ADD16mc
/* 41 */      MCD::OPC_FilterValue, 3, 234, 0, // Skip to: 279
/* 45 */      MCD::OPC_Decode, 194, 2, 21, // Opcode: ADD8mc
/* 49 */      MCD::OPC_FilterValue, 6, 19, 0, // Skip to: 72
/* 53 */      MCD::OPC_ExtractField, 6, 2,  // Inst{7-6} ...
/* 56 */      MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 64
/* 60 */      MCD::OPC_Decode, 206, 2, 21, // Opcode: ADDC16mc
/* 64 */      MCD::OPC_FilterValue, 3, 211, 0, // Skip to: 279
/* 68 */      MCD::OPC_Decode, 218, 2, 21, // Opcode: ADDC8mc
/* 72 */      MCD::OPC_FilterValue, 7, 19, 0, // Skip to: 95
/* 76 */      MCD::OPC_ExtractField, 6, 2,  // Inst{7-6} ...
/* 79 */      MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 87
/* 83 */      MCD::OPC_Decode, 208, 4, 21, // Opcode: SUBC16mc
/* 87 */      MCD::OPC_FilterValue, 3, 188, 0, // Skip to: 279
/* 91 */      MCD::OPC_Decode, 220, 4, 21, // Opcode: SUBC8mc
/* 95 */      MCD::OPC_FilterValue, 8, 19, 0, // Skip to: 118
/* 99 */      MCD::OPC_ExtractField, 6, 2,  // Inst{7-6} ...
/* 102 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 110
/* 106 */     MCD::OPC_Decode, 184, 4, 21, // Opcode: SUB16mc
/* 110 */     MCD::OPC_FilterValue, 3, 165, 0, // Skip to: 279
/* 114 */     MCD::OPC_Decode, 196, 4, 21, // Opcode: SUB8mc
/* 118 */     MCD::OPC_FilterValue, 9, 19, 0, // Skip to: 141
/* 122 */     MCD::OPC_ExtractField, 6, 2,  // Inst{7-6} ...
/* 125 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 133
/* 129 */     MCD::OPC_Decode, 209, 3, 21, // Opcode: CMP16mc
/* 133 */     MCD::OPC_FilterValue, 3, 142, 0, // Skip to: 279
/* 137 */     MCD::OPC_Decode, 221, 3, 21, // Opcode: CMP8mc
/* 141 */     MCD::OPC_FilterValue, 10, 19, 0, // Skip to: 164
/* 145 */     MCD::OPC_ExtractField, 6, 2,  // Inst{7-6} ...
/* 148 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 156
/* 152 */     MCD::OPC_Decode, 233, 3, 21, // Opcode: DADD16mc
/* 156 */     MCD::OPC_FilterValue, 3, 119, 0, // Skip to: 279
/* 160 */     MCD::OPC_Decode, 245, 3, 21, // Opcode: DADD8mc
/* 164 */     MCD::OPC_FilterValue, 11, 19, 0, // Skip to: 187
/* 168 */     MCD::OPC_ExtractField, 6, 2,  // Inst{7-6} ...
/* 171 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 179
/* 175 */     MCD::OPC_Decode, 177, 3, 21, // Opcode: BIT16mc
/* 179 */     MCD::OPC_FilterValue, 3, 96, 0, // Skip to: 279
/* 183 */     MCD::OPC_Decode, 189, 3, 21, // Opcode: BIT8mc
/* 187 */     MCD::OPC_FilterValue, 12, 19, 0, // Skip to: 210
/* 191 */     MCD::OPC_ExtractField, 6, 2,  // Inst{7-6} ...
/* 194 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 202
/* 198 */     MCD::OPC_Decode, 129, 3, 21, // Opcode: BIC16mc
/* 202 */     MCD::OPC_FilterValue, 3, 73, 0, // Skip to: 279
/* 206 */     MCD::OPC_Decode, 141, 3, 21, // Opcode: BIC8mc
/* 210 */     MCD::OPC_FilterValue, 13, 19, 0, // Skip to: 233
/* 214 */     MCD::OPC_ExtractField, 6, 2,  // Inst{7-6} ...
/* 217 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 225
/* 221 */     MCD::OPC_Decode, 153, 3, 21, // Opcode: BIS16mc
/* 225 */     MCD::OPC_FilterValue, 3, 50, 0, // Skip to: 279
/* 229 */     MCD::OPC_Decode, 165, 3, 21, // Opcode: BIS8mc
/* 233 */     MCD::OPC_FilterValue, 14, 19, 0, // Skip to: 256
/* 237 */     MCD::OPC_ExtractField, 6, 2,  // Inst{7-6} ...
/* 240 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 248
/* 244 */     MCD::OPC_Decode, 244, 4, 21, // Opcode: XOR16mc
/* 248 */     MCD::OPC_FilterValue, 3, 27, 0, // Skip to: 279
/* 252 */     MCD::OPC_Decode, 128, 5, 21, // Opcode: XOR8mc
/* 256 */     MCD::OPC_FilterValue, 15, 19, 0, // Skip to: 279
/* 260 */     MCD::OPC_ExtractField, 6, 2,  // Inst{7-6} ...
/* 263 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 271
/* 267 */     MCD::OPC_Decode, 233, 2, 21, // Opcode: AND16mc
/* 271 */     MCD::OPC_FilterValue, 3, 4, 0, // Skip to: 279
/* 275 */     MCD::OPC_Decode, 245, 2, 21, // Opcode: AND8mc
/* 279 */     MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableDelta16[] = {
/* 0 */       MCD::OPC_ExtractField, 12, 4,  // Inst{15-12} ...
/* 3 */       MCD::OPC_FilterValue, 4, 61, 0, // Skip to: 68
/* 7 */       MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 10 */      MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 18
/* 14 */      MCD::OPC_Decode, 139, 4, 11, // Opcode: MOV16rn
/* 18 */      MCD::OPC_FilterValue, 3, 30, 0, // Skip to: 52
/* 22 */      MCD::OPC_CheckField, 8, 4, 1, 10, 0, // Skip to: 38
/* 28 */      MCD::OPC_CheckField, 0, 4, 0, 4, 0, // Skip to: 38
/* 34 */      MCD::OPC_Decode, 160, 4, 5, // Opcode: RET
/* 38 */      MCD::OPC_CheckField, 8, 4, 1, 4, 0, // Skip to: 48
/* 44 */      MCD::OPC_Decode, 155, 4, 1, // Opcode: POP16r
/* 48 */      MCD::OPC_Decode, 140, 4, 22, // Opcode: MOV16rp
/* 52 */      MCD::OPC_FilterValue, 6, 4, 0, // Skip to: 60
/* 56 */      MCD::OPC_Decode, 150, 4, 23, // Opcode: MOV8rn
/* 60 */      MCD::OPC_FilterValue, 7, 177, 1, // Skip to: 497
/* 64 */      MCD::OPC_Decode, 151, 4, 24, // Opcode: MOV8rp
/* 68 */      MCD::OPC_FilterValue, 5, 35, 0, // Skip to: 107
/* 72 */      MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 75 */      MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 83
/* 79 */      MCD::OPC_Decode, 191, 2, 13, // Opcode: ADD16rn
/* 83 */      MCD::OPC_FilterValue, 3, 4, 0, // Skip to: 91
/* 87 */      MCD::OPC_Decode, 192, 2, 25, // Opcode: ADD16rp
/* 91 */      MCD::OPC_FilterValue, 6, 4, 0, // Skip to: 99
/* 95 */      MCD::OPC_Decode, 203, 2, 26, // Opcode: ADD8rn
/* 99 */      MCD::OPC_FilterValue, 7, 138, 1, // Skip to: 497
/* 103 */     MCD::OPC_Decode, 204, 2, 27, // Opcode: ADD8rp
/* 107 */     MCD::OPC_FilterValue, 6, 35, 0, // Skip to: 146
/* 111 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 114 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 122
/* 118 */     MCD::OPC_Decode, 215, 2, 13, // Opcode: ADDC16rn
/* 122 */     MCD::OPC_FilterValue, 3, 4, 0, // Skip to: 130
/* 126 */     MCD::OPC_Decode, 216, 2, 25, // Opcode: ADDC16rp
/* 130 */     MCD::OPC_FilterValue, 6, 4, 0, // Skip to: 138
/* 134 */     MCD::OPC_Decode, 227, 2, 26, // Opcode: ADDC8rn
/* 138 */     MCD::OPC_FilterValue, 7, 99, 1, // Skip to: 497
/* 142 */     MCD::OPC_Decode, 228, 2, 27, // Opcode: ADDC8rp
/* 146 */     MCD::OPC_FilterValue, 7, 35, 0, // Skip to: 185
/* 150 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 153 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 161
/* 157 */     MCD::OPC_Decode, 217, 4, 13, // Opcode: SUBC16rn
/* 161 */     MCD::OPC_FilterValue, 3, 4, 0, // Skip to: 169
/* 165 */     MCD::OPC_Decode, 218, 4, 25, // Opcode: SUBC16rp
/* 169 */     MCD::OPC_FilterValue, 6, 4, 0, // Skip to: 177
/* 173 */     MCD::OPC_Decode, 229, 4, 26, // Opcode: SUBC8rn
/* 177 */     MCD::OPC_FilterValue, 7, 60, 1, // Skip to: 497
/* 181 */     MCD::OPC_Decode, 230, 4, 27, // Opcode: SUBC8rp
/* 185 */     MCD::OPC_FilterValue, 8, 35, 0, // Skip to: 224
/* 189 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 192 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 200
/* 196 */     MCD::OPC_Decode, 193, 4, 13, // Opcode: SUB16rn
/* 200 */     MCD::OPC_FilterValue, 3, 4, 0, // Skip to: 208
/* 204 */     MCD::OPC_Decode, 194, 4, 25, // Opcode: SUB16rp
/* 208 */     MCD::OPC_FilterValue, 6, 4, 0, // Skip to: 216
/* 212 */     MCD::OPC_Decode, 205, 4, 26, // Opcode: SUB8rn
/* 216 */     MCD::OPC_FilterValue, 7, 21, 1, // Skip to: 497
/* 220 */     MCD::OPC_Decode, 206, 4, 27, // Opcode: SUB8rp
/* 224 */     MCD::OPC_FilterValue, 9, 35, 0, // Skip to: 263
/* 228 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 231 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 239
/* 235 */     MCD::OPC_Decode, 218, 3, 11, // Opcode: CMP16rn
/* 239 */     MCD::OPC_FilterValue, 3, 4, 0, // Skip to: 247
/* 243 */     MCD::OPC_Decode, 219, 3, 11, // Opcode: CMP16rp
/* 247 */     MCD::OPC_FilterValue, 6, 4, 0, // Skip to: 255
/* 251 */     MCD::OPC_Decode, 230, 3, 23, // Opcode: CMP8rn
/* 255 */     MCD::OPC_FilterValue, 7, 238, 0, // Skip to: 497
/* 259 */     MCD::OPC_Decode, 231, 3, 23, // Opcode: CMP8rp
/* 263 */     MCD::OPC_FilterValue, 10, 35, 0, // Skip to: 302
/* 267 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 270 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 278
/* 274 */     MCD::OPC_Decode, 242, 3, 13, // Opcode: DADD16rn
/* 278 */     MCD::OPC_FilterValue, 3, 4, 0, // Skip to: 286
/* 282 */     MCD::OPC_Decode, 243, 3, 25, // Opcode: DADD16rp
/* 286 */     MCD::OPC_FilterValue, 6, 4, 0, // Skip to: 294
/* 290 */     MCD::OPC_Decode, 254, 3, 26, // Opcode: DADD8rn
/* 294 */     MCD::OPC_FilterValue, 7, 199, 0, // Skip to: 497
/* 298 */     MCD::OPC_Decode, 255, 3, 27, // Opcode: DADD8rp
/* 302 */     MCD::OPC_FilterValue, 11, 35, 0, // Skip to: 341
/* 306 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 309 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 317
/* 313 */     MCD::OPC_Decode, 186, 3, 11, // Opcode: BIT16rn
/* 317 */     MCD::OPC_FilterValue, 3, 4, 0, // Skip to: 325
/* 321 */     MCD::OPC_Decode, 187, 3, 11, // Opcode: BIT16rp
/* 325 */     MCD::OPC_FilterValue, 6, 4, 0, // Skip to: 333
/* 329 */     MCD::OPC_Decode, 198, 3, 23, // Opcode: BIT8rn
/* 333 */     MCD::OPC_FilterValue, 7, 160, 0, // Skip to: 497
/* 337 */     MCD::OPC_Decode, 199, 3, 23, // Opcode: BIT8rp
/* 341 */     MCD::OPC_FilterValue, 12, 35, 0, // Skip to: 380
/* 345 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 348 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 356
/* 352 */     MCD::OPC_Decode, 138, 3, 13, // Opcode: BIC16rn
/* 356 */     MCD::OPC_FilterValue, 3, 4, 0, // Skip to: 364
/* 360 */     MCD::OPC_Decode, 139, 3, 25, // Opcode: BIC16rp
/* 364 */     MCD::OPC_FilterValue, 6, 4, 0, // Skip to: 372
/* 368 */     MCD::OPC_Decode, 150, 3, 26, // Opcode: BIC8rn
/* 372 */     MCD::OPC_FilterValue, 7, 121, 0, // Skip to: 497
/* 376 */     MCD::OPC_Decode, 151, 3, 27, // Opcode: BIC8rp
/* 380 */     MCD::OPC_FilterValue, 13, 35, 0, // Skip to: 419
/* 384 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 387 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 395
/* 391 */     MCD::OPC_Decode, 162, 3, 13, // Opcode: BIS16rn
/* 395 */     MCD::OPC_FilterValue, 3, 4, 0, // Skip to: 403
/* 399 */     MCD::OPC_Decode, 163, 3, 25, // Opcode: BIS16rp
/* 403 */     MCD::OPC_FilterValue, 6, 4, 0, // Skip to: 411
/* 407 */     MCD::OPC_Decode, 174, 3, 26, // Opcode: BIS8rn
/* 411 */     MCD::OPC_FilterValue, 7, 82, 0, // Skip to: 497
/* 415 */     MCD::OPC_Decode, 175, 3, 27, // Opcode: BIS8rp
/* 419 */     MCD::OPC_FilterValue, 14, 35, 0, // Skip to: 458
/* 423 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 426 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 434
/* 430 */     MCD::OPC_Decode, 253, 4, 13, // Opcode: XOR16rn
/* 434 */     MCD::OPC_FilterValue, 3, 4, 0, // Skip to: 442
/* 438 */     MCD::OPC_Decode, 254, 4, 25, // Opcode: XOR16rp
/* 442 */     MCD::OPC_FilterValue, 6, 4, 0, // Skip to: 450
/* 446 */     MCD::OPC_Decode, 137, 5, 26, // Opcode: XOR8rn
/* 450 */     MCD::OPC_FilterValue, 7, 43, 0, // Skip to: 497
/* 454 */     MCD::OPC_Decode, 138, 5, 27, // Opcode: XOR8rp
/* 458 */     MCD::OPC_FilterValue, 15, 35, 0, // Skip to: 497
/* 462 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 465 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 473
/* 469 */     MCD::OPC_Decode, 242, 2, 13, // Opcode: AND16rn
/* 473 */     MCD::OPC_FilterValue, 3, 4, 0, // Skip to: 481
/* 477 */     MCD::OPC_Decode, 243, 2, 25, // Opcode: AND16rp
/* 481 */     MCD::OPC_FilterValue, 6, 4, 0, // Skip to: 489
/* 485 */     MCD::OPC_Decode, 254, 2, 26, // Opcode: AND8rn
/* 489 */     MCD::OPC_FilterValue, 7, 4, 0, // Skip to: 497
/* 493 */     MCD::OPC_Decode, 255, 2, 27, // Opcode: AND8rp
/* 497 */     MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableDelta32[] = {
/* 0 */       MCD::OPC_ExtractField, 12, 4,  // Inst{15-12} ...
/* 3 */       MCD::OPC_FilterValue, 4, 19, 0, // Skip to: 26
/* 7 */       MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 10 */      MCD::OPC_FilterValue, 10, 4, 0, // Skip to: 18
/* 14 */      MCD::OPC_Decode, 134, 4, 15, // Opcode: MOV16mn
/* 18 */      MCD::OPC_FilterValue, 14, 177, 1, // Skip to: 455
/* 22 */      MCD::OPC_Decode, 145, 4, 15, // Opcode: MOV8mn
/* 26 */      MCD::OPC_FilterValue, 5, 35, 0, // Skip to: 65
/* 30 */      MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 33 */      MCD::OPC_FilterValue, 10, 4, 0, // Skip to: 41
/* 37 */      MCD::OPC_Decode, 185, 2, 15, // Opcode: ADD16mn
/* 41 */      MCD::OPC_FilterValue, 11, 4, 0, // Skip to: 49
/* 45 */      MCD::OPC_Decode, 186, 2, 15, // Opcode: ADD16mp
/* 49 */      MCD::OPC_FilterValue, 14, 4, 0, // Skip to: 57
/* 53 */      MCD::OPC_Decode, 197, 2, 15, // Opcode: ADD8mn
/* 57 */      MCD::OPC_FilterValue, 15, 138, 1, // Skip to: 455
/* 61 */      MCD::OPC_Decode, 198, 2, 15, // Opcode: ADD8mp
/* 65 */      MCD::OPC_FilterValue, 6, 35, 0, // Skip to: 104
/* 69 */      MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 72 */      MCD::OPC_FilterValue, 10, 4, 0, // Skip to: 80
/* 76 */      MCD::OPC_Decode, 209, 2, 15, // Opcode: ADDC16mn
/* 80 */      MCD::OPC_FilterValue, 11, 4, 0, // Skip to: 88
/* 84 */      MCD::OPC_Decode, 210, 2, 15, // Opcode: ADDC16mp
/* 88 */      MCD::OPC_FilterValue, 14, 4, 0, // Skip to: 96
/* 92 */      MCD::OPC_Decode, 221, 2, 15, // Opcode: ADDC8mn
/* 96 */      MCD::OPC_FilterValue, 15, 99, 1, // Skip to: 455
/* 100 */     MCD::OPC_Decode, 222, 2, 15, // Opcode: ADDC8mp
/* 104 */     MCD::OPC_FilterValue, 7, 35, 0, // Skip to: 143
/* 108 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 111 */     MCD::OPC_FilterValue, 10, 4, 0, // Skip to: 119
/* 115 */     MCD::OPC_Decode, 211, 4, 15, // Opcode: SUBC16mn
/* 119 */     MCD::OPC_FilterValue, 11, 4, 0, // Skip to: 127
/* 123 */     MCD::OPC_Decode, 212, 4, 15, // Opcode: SUBC16mp
/* 127 */     MCD::OPC_FilterValue, 14, 4, 0, // Skip to: 135
/* 131 */     MCD::OPC_Decode, 223, 4, 15, // Opcode: SUBC8mn
/* 135 */     MCD::OPC_FilterValue, 15, 60, 1, // Skip to: 455
/* 139 */     MCD::OPC_Decode, 224, 4, 15, // Opcode: SUBC8mp
/* 143 */     MCD::OPC_FilterValue, 8, 35, 0, // Skip to: 182
/* 147 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 150 */     MCD::OPC_FilterValue, 10, 4, 0, // Skip to: 158
/* 154 */     MCD::OPC_Decode, 187, 4, 15, // Opcode: SUB16mn
/* 158 */     MCD::OPC_FilterValue, 11, 4, 0, // Skip to: 166
/* 162 */     MCD::OPC_Decode, 188, 4, 15, // Opcode: SUB16mp
/* 166 */     MCD::OPC_FilterValue, 14, 4, 0, // Skip to: 174
/* 170 */     MCD::OPC_Decode, 199, 4, 15, // Opcode: SUB8mn
/* 174 */     MCD::OPC_FilterValue, 15, 21, 1, // Skip to: 455
/* 178 */     MCD::OPC_Decode, 200, 4, 15, // Opcode: SUB8mp
/* 182 */     MCD::OPC_FilterValue, 9, 35, 0, // Skip to: 221
/* 186 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 189 */     MCD::OPC_FilterValue, 10, 4, 0, // Skip to: 197
/* 193 */     MCD::OPC_Decode, 212, 3, 15, // Opcode: CMP16mn
/* 197 */     MCD::OPC_FilterValue, 11, 4, 0, // Skip to: 205
/* 201 */     MCD::OPC_Decode, 213, 3, 15, // Opcode: CMP16mp
/* 205 */     MCD::OPC_FilterValue, 14, 4, 0, // Skip to: 213
/* 209 */     MCD::OPC_Decode, 224, 3, 15, // Opcode: CMP8mn
/* 213 */     MCD::OPC_FilterValue, 15, 238, 0, // Skip to: 455
/* 217 */     MCD::OPC_Decode, 225, 3, 15, // Opcode: CMP8mp
/* 221 */     MCD::OPC_FilterValue, 10, 35, 0, // Skip to: 260
/* 225 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 228 */     MCD::OPC_FilterValue, 10, 4, 0, // Skip to: 236
/* 232 */     MCD::OPC_Decode, 236, 3, 15, // Opcode: DADD16mn
/* 236 */     MCD::OPC_FilterValue, 11, 4, 0, // Skip to: 244
/* 240 */     MCD::OPC_Decode, 237, 3, 15, // Opcode: DADD16mp
/* 244 */     MCD::OPC_FilterValue, 14, 4, 0, // Skip to: 252
/* 248 */     MCD::OPC_Decode, 248, 3, 15, // Opcode: DADD8mn
/* 252 */     MCD::OPC_FilterValue, 15, 199, 0, // Skip to: 455
/* 256 */     MCD::OPC_Decode, 249, 3, 15, // Opcode: DADD8mp
/* 260 */     MCD::OPC_FilterValue, 11, 35, 0, // Skip to: 299
/* 264 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 267 */     MCD::OPC_FilterValue, 10, 4, 0, // Skip to: 275
/* 271 */     MCD::OPC_Decode, 180, 3, 15, // Opcode: BIT16mn
/* 275 */     MCD::OPC_FilterValue, 11, 4, 0, // Skip to: 283
/* 279 */     MCD::OPC_Decode, 181, 3, 15, // Opcode: BIT16mp
/* 283 */     MCD::OPC_FilterValue, 14, 4, 0, // Skip to: 291
/* 287 */     MCD::OPC_Decode, 192, 3, 15, // Opcode: BIT8mn
/* 291 */     MCD::OPC_FilterValue, 15, 160, 0, // Skip to: 455
/* 295 */     MCD::OPC_Decode, 193, 3, 15, // Opcode: BIT8mp
/* 299 */     MCD::OPC_FilterValue, 12, 35, 0, // Skip to: 338
/* 303 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 306 */     MCD::OPC_FilterValue, 10, 4, 0, // Skip to: 314
/* 310 */     MCD::OPC_Decode, 132, 3, 15, // Opcode: BIC16mn
/* 314 */     MCD::OPC_FilterValue, 11, 4, 0, // Skip to: 322
/* 318 */     MCD::OPC_Decode, 133, 3, 15, // Opcode: BIC16mp
/* 322 */     MCD::OPC_FilterValue, 14, 4, 0, // Skip to: 330
/* 326 */     MCD::OPC_Decode, 144, 3, 15, // Opcode: BIC8mn
/* 330 */     MCD::OPC_FilterValue, 15, 121, 0, // Skip to: 455
/* 334 */     MCD::OPC_Decode, 145, 3, 15, // Opcode: BIC8mp
/* 338 */     MCD::OPC_FilterValue, 13, 35, 0, // Skip to: 377
/* 342 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 345 */     MCD::OPC_FilterValue, 10, 4, 0, // Skip to: 353
/* 349 */     MCD::OPC_Decode, 156, 3, 15, // Opcode: BIS16mn
/* 353 */     MCD::OPC_FilterValue, 11, 4, 0, // Skip to: 361
/* 357 */     MCD::OPC_Decode, 157, 3, 15, // Opcode: BIS16mp
/* 361 */     MCD::OPC_FilterValue, 14, 4, 0, // Skip to: 369
/* 365 */     MCD::OPC_Decode, 168, 3, 15, // Opcode: BIS8mn
/* 369 */     MCD::OPC_FilterValue, 15, 82, 0, // Skip to: 455
/* 373 */     MCD::OPC_Decode, 169, 3, 15, // Opcode: BIS8mp
/* 377 */     MCD::OPC_FilterValue, 14, 35, 0, // Skip to: 416
/* 381 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 384 */     MCD::OPC_FilterValue, 10, 4, 0, // Skip to: 392
/* 388 */     MCD::OPC_Decode, 247, 4, 15, // Opcode: XOR16mn
/* 392 */     MCD::OPC_FilterValue, 11, 4, 0, // Skip to: 400
/* 396 */     MCD::OPC_Decode, 248, 4, 15, // Opcode: XOR16mp
/* 400 */     MCD::OPC_FilterValue, 14, 4, 0, // Skip to: 408
/* 404 */     MCD::OPC_Decode, 131, 5, 15, // Opcode: XOR8mn
/* 408 */     MCD::OPC_FilterValue, 15, 43, 0, // Skip to: 455
/* 412 */     MCD::OPC_Decode, 132, 5, 15, // Opcode: XOR8mp
/* 416 */     MCD::OPC_FilterValue, 15, 35, 0, // Skip to: 455
/* 420 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 423 */     MCD::OPC_FilterValue, 10, 4, 0, // Skip to: 431
/* 427 */     MCD::OPC_Decode, 236, 2, 15, // Opcode: AND16mn
/* 431 */     MCD::OPC_FilterValue, 11, 4, 0, // Skip to: 439
/* 435 */     MCD::OPC_Decode, 237, 2, 15, // Opcode: AND16mp
/* 439 */     MCD::OPC_FilterValue, 14, 4, 0, // Skip to: 447
/* 443 */     MCD::OPC_Decode, 248, 2, 15, // Opcode: AND8mn
/* 447 */     MCD::OPC_FilterValue, 15, 4, 0, // Skip to: 455
/* 451 */     MCD::OPC_Decode, 249, 2, 15, // Opcode: AND8mp
/* 455 */     MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableGamma32[] = {
/* 0 */       MCD::OPC_ExtractField, 12, 4,  // Inst{15-12} ...
/* 3 */       MCD::OPC_FilterValue, 4, 68, 0, // Skip to: 75
/* 7 */       MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 10 */      MCD::OPC_FilterValue, 1, 14, 0, // Skip to: 28
/* 14 */      MCD::OPC_CheckField, 0, 4, 0, 4, 0, // Skip to: 24
/* 20 */      MCD::OPC_Decode, 202, 3, 28, // Opcode: Bm
/* 24 */      MCD::OPC_Decode, 138, 4, 29, // Opcode: MOV16rm
/* 28 */      MCD::OPC_FilterValue, 3, 21, 0, // Skip to: 53
/* 32 */      MCD::OPC_ExtractField, 8, 4,  // Inst{11-8} ...
/* 35 */      MCD::OPC_FilterValue, 0, 85, 2, // Skip to: 636
/* 39 */      MCD::OPC_CheckField, 0, 4, 0, 4, 0, // Skip to: 49
/* 45 */      MCD::OPC_Decode, 201, 3, 9, // Opcode: Bi
/* 49 */      MCD::OPC_Decode, 137, 4, 30, // Opcode: MOV16ri
/* 53 */      MCD::OPC_FilterValue, 5, 4, 0, // Skip to: 61
/* 57 */      MCD::OPC_Decode, 149, 4, 31, // Opcode: MOV8rm
/* 61 */      MCD::OPC_FilterValue, 7, 59, 2, // Skip to: 636
/* 65 */      MCD::OPC_CheckField, 8, 4, 0, 53, 2, // Skip to: 636
/* 71 */      MCD::OPC_Decode, 148, 4, 32, // Opcode: MOV8ri
/* 75 */      MCD::OPC_FilterValue, 5, 47, 0, // Skip to: 126
/* 79 */      MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 82 */      MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 90
/* 86 */      MCD::OPC_Decode, 190, 2, 33, // Opcode: ADD16rm
/* 90 */      MCD::OPC_FilterValue, 3, 10, 0, // Skip to: 104
/* 94 */      MCD::OPC_CheckField, 8, 4, 0, 24, 2, // Skip to: 636
/* 100 */     MCD::OPC_Decode, 189, 2, 34, // Opcode: ADD16ri
/* 104 */     MCD::OPC_FilterValue, 5, 4, 0, // Skip to: 112
/* 108 */     MCD::OPC_Decode, 202, 2, 35, // Opcode: ADD8rm
/* 112 */     MCD::OPC_FilterValue, 7, 8, 2, // Skip to: 636
/* 116 */     MCD::OPC_CheckField, 8, 4, 0, 2, 2, // Skip to: 636
/* 122 */     MCD::OPC_Decode, 201, 2, 36, // Opcode: ADD8ri
/* 126 */     MCD::OPC_FilterValue, 6, 47, 0, // Skip to: 177
/* 130 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 133 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 141
/* 137 */     MCD::OPC_Decode, 214, 2, 33, // Opcode: ADDC16rm
/* 141 */     MCD::OPC_FilterValue, 3, 10, 0, // Skip to: 155
/* 145 */     MCD::OPC_CheckField, 8, 4, 0, 229, 1, // Skip to: 636
/* 151 */     MCD::OPC_Decode, 213, 2, 34, // Opcode: ADDC16ri
/* 155 */     MCD::OPC_FilterValue, 5, 4, 0, // Skip to: 163
/* 159 */     MCD::OPC_Decode, 226, 2, 35, // Opcode: ADDC8rm
/* 163 */     MCD::OPC_FilterValue, 7, 213, 1, // Skip to: 636
/* 167 */     MCD::OPC_CheckField, 8, 4, 0, 207, 1, // Skip to: 636
/* 173 */     MCD::OPC_Decode, 225, 2, 36, // Opcode: ADDC8ri
/* 177 */     MCD::OPC_FilterValue, 7, 47, 0, // Skip to: 228
/* 181 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 184 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 192
/* 188 */     MCD::OPC_Decode, 216, 4, 33, // Opcode: SUBC16rm
/* 192 */     MCD::OPC_FilterValue, 3, 10, 0, // Skip to: 206
/* 196 */     MCD::OPC_CheckField, 8, 4, 0, 178, 1, // Skip to: 636
/* 202 */     MCD::OPC_Decode, 215, 4, 34, // Opcode: SUBC16ri
/* 206 */     MCD::OPC_FilterValue, 5, 4, 0, // Skip to: 214
/* 210 */     MCD::OPC_Decode, 228, 4, 35, // Opcode: SUBC8rm
/* 214 */     MCD::OPC_FilterValue, 7, 162, 1, // Skip to: 636
/* 218 */     MCD::OPC_CheckField, 8, 4, 0, 156, 1, // Skip to: 636
/* 224 */     MCD::OPC_Decode, 227, 4, 36, // Opcode: SUBC8ri
/* 228 */     MCD::OPC_FilterValue, 8, 47, 0, // Skip to: 279
/* 232 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 235 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 243
/* 239 */     MCD::OPC_Decode, 192, 4, 33, // Opcode: SUB16rm
/* 243 */     MCD::OPC_FilterValue, 3, 10, 0, // Skip to: 257
/* 247 */     MCD::OPC_CheckField, 8, 4, 0, 127, 1, // Skip to: 636
/* 253 */     MCD::OPC_Decode, 191, 4, 34, // Opcode: SUB16ri
/* 257 */     MCD::OPC_FilterValue, 5, 4, 0, // Skip to: 265
/* 261 */     MCD::OPC_Decode, 204, 4, 35, // Opcode: SUB8rm
/* 265 */     MCD::OPC_FilterValue, 7, 111, 1, // Skip to: 636
/* 269 */     MCD::OPC_CheckField, 8, 4, 0, 105, 1, // Skip to: 636
/* 275 */     MCD::OPC_Decode, 203, 4, 36, // Opcode: SUB8ri
/* 279 */     MCD::OPC_FilterValue, 9, 47, 0, // Skip to: 330
/* 283 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 286 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 294
/* 290 */     MCD::OPC_Decode, 217, 3, 29, // Opcode: CMP16rm
/* 294 */     MCD::OPC_FilterValue, 3, 10, 0, // Skip to: 308
/* 298 */     MCD::OPC_CheckField, 8, 4, 0, 76, 1, // Skip to: 636
/* 304 */     MCD::OPC_Decode, 216, 3, 30, // Opcode: CMP16ri
/* 308 */     MCD::OPC_FilterValue, 5, 4, 0, // Skip to: 316
/* 312 */     MCD::OPC_Decode, 229, 3, 31, // Opcode: CMP8rm
/* 316 */     MCD::OPC_FilterValue, 7, 60, 1, // Skip to: 636
/* 320 */     MCD::OPC_CheckField, 8, 4, 0, 54, 1, // Skip to: 636
/* 326 */     MCD::OPC_Decode, 228, 3, 32, // Opcode: CMP8ri
/* 330 */     MCD::OPC_FilterValue, 10, 47, 0, // Skip to: 381
/* 334 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 337 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 345
/* 341 */     MCD::OPC_Decode, 241, 3, 33, // Opcode: DADD16rm
/* 345 */     MCD::OPC_FilterValue, 3, 10, 0, // Skip to: 359
/* 349 */     MCD::OPC_CheckField, 8, 4, 0, 25, 1, // Skip to: 636
/* 355 */     MCD::OPC_Decode, 240, 3, 34, // Opcode: DADD16ri
/* 359 */     MCD::OPC_FilterValue, 5, 4, 0, // Skip to: 367
/* 363 */     MCD::OPC_Decode, 253, 3, 35, // Opcode: DADD8rm
/* 367 */     MCD::OPC_FilterValue, 7, 9, 1, // Skip to: 636
/* 371 */     MCD::OPC_CheckField, 8, 4, 0, 3, 1, // Skip to: 636
/* 377 */     MCD::OPC_Decode, 252, 3, 36, // Opcode: DADD8ri
/* 381 */     MCD::OPC_FilterValue, 11, 47, 0, // Skip to: 432
/* 385 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 388 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 396
/* 392 */     MCD::OPC_Decode, 185, 3, 29, // Opcode: BIT16rm
/* 396 */     MCD::OPC_FilterValue, 3, 10, 0, // Skip to: 410
/* 400 */     MCD::OPC_CheckField, 8, 4, 0, 230, 0, // Skip to: 636
/* 406 */     MCD::OPC_Decode, 184, 3, 30, // Opcode: BIT16ri
/* 410 */     MCD::OPC_FilterValue, 5, 4, 0, // Skip to: 418
/* 414 */     MCD::OPC_Decode, 197, 3, 31, // Opcode: BIT8rm
/* 418 */     MCD::OPC_FilterValue, 7, 214, 0, // Skip to: 636
/* 422 */     MCD::OPC_CheckField, 8, 4, 0, 208, 0, // Skip to: 636
/* 428 */     MCD::OPC_Decode, 196, 3, 32, // Opcode: BIT8ri
/* 432 */     MCD::OPC_FilterValue, 12, 47, 0, // Skip to: 483
/* 436 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 439 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 447
/* 443 */     MCD::OPC_Decode, 137, 3, 33, // Opcode: BIC16rm
/* 447 */     MCD::OPC_FilterValue, 3, 10, 0, // Skip to: 461
/* 451 */     MCD::OPC_CheckField, 8, 4, 0, 179, 0, // Skip to: 636
/* 457 */     MCD::OPC_Decode, 136, 3, 34, // Opcode: BIC16ri
/* 461 */     MCD::OPC_FilterValue, 5, 4, 0, // Skip to: 469
/* 465 */     MCD::OPC_Decode, 149, 3, 35, // Opcode: BIC8rm
/* 469 */     MCD::OPC_FilterValue, 7, 163, 0, // Skip to: 636
/* 473 */     MCD::OPC_CheckField, 8, 4, 0, 157, 0, // Skip to: 636
/* 479 */     MCD::OPC_Decode, 148, 3, 36, // Opcode: BIC8ri
/* 483 */     MCD::OPC_FilterValue, 13, 47, 0, // Skip to: 534
/* 487 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 490 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 498
/* 494 */     MCD::OPC_Decode, 161, 3, 33, // Opcode: BIS16rm
/* 498 */     MCD::OPC_FilterValue, 3, 10, 0, // Skip to: 512
/* 502 */     MCD::OPC_CheckField, 8, 4, 0, 128, 0, // Skip to: 636
/* 508 */     MCD::OPC_Decode, 160, 3, 34, // Opcode: BIS16ri
/* 512 */     MCD::OPC_FilterValue, 5, 4, 0, // Skip to: 520
/* 516 */     MCD::OPC_Decode, 173, 3, 35, // Opcode: BIS8rm
/* 520 */     MCD::OPC_FilterValue, 7, 112, 0, // Skip to: 636
/* 524 */     MCD::OPC_CheckField, 8, 4, 0, 106, 0, // Skip to: 636
/* 530 */     MCD::OPC_Decode, 172, 3, 36, // Opcode: BIS8ri
/* 534 */     MCD::OPC_FilterValue, 14, 47, 0, // Skip to: 585
/* 538 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 541 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 549
/* 545 */     MCD::OPC_Decode, 252, 4, 33, // Opcode: XOR16rm
/* 549 */     MCD::OPC_FilterValue, 3, 10, 0, // Skip to: 563
/* 553 */     MCD::OPC_CheckField, 8, 4, 0, 77, 0, // Skip to: 636
/* 559 */     MCD::OPC_Decode, 251, 4, 34, // Opcode: XOR16ri
/* 563 */     MCD::OPC_FilterValue, 5, 4, 0, // Skip to: 571
/* 567 */     MCD::OPC_Decode, 136, 5, 35, // Opcode: XOR8rm
/* 571 */     MCD::OPC_FilterValue, 7, 61, 0, // Skip to: 636
/* 575 */     MCD::OPC_CheckField, 8, 4, 0, 55, 0, // Skip to: 636
/* 581 */     MCD::OPC_Decode, 135, 5, 36, // Opcode: XOR8ri
/* 585 */     MCD::OPC_FilterValue, 15, 47, 0, // Skip to: 636
/* 589 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 592 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 600
/* 596 */     MCD::OPC_Decode, 241, 2, 33, // Opcode: AND16rm
/* 600 */     MCD::OPC_FilterValue, 3, 10, 0, // Skip to: 614
/* 604 */     MCD::OPC_CheckField, 8, 4, 0, 26, 0, // Skip to: 636
/* 610 */     MCD::OPC_Decode, 240, 2, 34, // Opcode: AND16ri
/* 614 */     MCD::OPC_FilterValue, 5, 4, 0, // Skip to: 622
/* 618 */     MCD::OPC_Decode, 253, 2, 35, // Opcode: AND8rm
/* 622 */     MCD::OPC_FilterValue, 7, 10, 0, // Skip to: 636
/* 626 */     MCD::OPC_CheckField, 8, 4, 0, 4, 0, // Skip to: 636
/* 632 */     MCD::OPC_Decode, 252, 2, 36, // Opcode: AND8ri
/* 636 */     MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableGamma48[] = {
/* 0 */       MCD::OPC_ExtractField, 12, 4,  // Inst{15-12} ...
/* 3 */       MCD::OPC_FilterValue, 4, 47, 0, // Skip to: 54
/* 7 */       MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 10 */      MCD::OPC_FilterValue, 9, 4, 0, // Skip to: 18
/* 14 */      MCD::OPC_Decode, 133, 4, 37, // Opcode: MOV16mm
/* 18 */      MCD::OPC_FilterValue, 11, 10, 0, // Skip to: 32
/* 22 */      MCD::OPC_CheckField, 8, 4, 0, 75, 2, // Skip to: 615
/* 28 */      MCD::OPC_Decode, 132, 4, 38, // Opcode: MOV16mi
/* 32 */      MCD::OPC_FilterValue, 13, 4, 0, // Skip to: 40
/* 36 */      MCD::OPC_Decode, 144, 4, 37, // Opcode: MOV8mm
/* 40 */      MCD::OPC_FilterValue, 15, 59, 2, // Skip to: 615
/* 44 */      MCD::OPC_CheckField, 8, 4, 0, 53, 2, // Skip to: 615
/* 50 */      MCD::OPC_Decode, 143, 4, 38, // Opcode: MOV8mi
/* 54 */      MCD::OPC_FilterValue, 5, 47, 0, // Skip to: 105
/* 58 */      MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 61 */      MCD::OPC_FilterValue, 9, 4, 0, // Skip to: 69
/* 65 */      MCD::OPC_Decode, 184, 2, 37, // Opcode: ADD16mm
/* 69 */      MCD::OPC_FilterValue, 11, 10, 0, // Skip to: 83
/* 73 */      MCD::OPC_CheckField, 8, 4, 0, 24, 2, // Skip to: 615
/* 79 */      MCD::OPC_Decode, 183, 2, 38, // Opcode: ADD16mi
/* 83 */      MCD::OPC_FilterValue, 13, 4, 0, // Skip to: 91
/* 87 */      MCD::OPC_Decode, 196, 2, 37, // Opcode: ADD8mm
/* 91 */      MCD::OPC_FilterValue, 15, 8, 2, // Skip to: 615
/* 95 */      MCD::OPC_CheckField, 8, 4, 0, 2, 2, // Skip to: 615
/* 101 */     MCD::OPC_Decode, 195, 2, 38, // Opcode: ADD8mi
/* 105 */     MCD::OPC_FilterValue, 6, 47, 0, // Skip to: 156
/* 109 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 112 */     MCD::OPC_FilterValue, 9, 4, 0, // Skip to: 120
/* 116 */     MCD::OPC_Decode, 208, 2, 37, // Opcode: ADDC16mm
/* 120 */     MCD::OPC_FilterValue, 11, 10, 0, // Skip to: 134
/* 124 */     MCD::OPC_CheckField, 8, 4, 0, 229, 1, // Skip to: 615
/* 130 */     MCD::OPC_Decode, 207, 2, 38, // Opcode: ADDC16mi
/* 134 */     MCD::OPC_FilterValue, 13, 4, 0, // Skip to: 142
/* 138 */     MCD::OPC_Decode, 220, 2, 37, // Opcode: ADDC8mm
/* 142 */     MCD::OPC_FilterValue, 15, 213, 1, // Skip to: 615
/* 146 */     MCD::OPC_CheckField, 8, 4, 0, 207, 1, // Skip to: 615
/* 152 */     MCD::OPC_Decode, 219, 2, 38, // Opcode: ADDC8mi
/* 156 */     MCD::OPC_FilterValue, 7, 47, 0, // Skip to: 207
/* 160 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 163 */     MCD::OPC_FilterValue, 9, 4, 0, // Skip to: 171
/* 167 */     MCD::OPC_Decode, 210, 4, 37, // Opcode: SUBC16mm
/* 171 */     MCD::OPC_FilterValue, 11, 10, 0, // Skip to: 185
/* 175 */     MCD::OPC_CheckField, 8, 4, 0, 178, 1, // Skip to: 615
/* 181 */     MCD::OPC_Decode, 209, 4, 38, // Opcode: SUBC16mi
/* 185 */     MCD::OPC_FilterValue, 13, 4, 0, // Skip to: 193
/* 189 */     MCD::OPC_Decode, 222, 4, 37, // Opcode: SUBC8mm
/* 193 */     MCD::OPC_FilterValue, 15, 162, 1, // Skip to: 615
/* 197 */     MCD::OPC_CheckField, 8, 4, 0, 156, 1, // Skip to: 615
/* 203 */     MCD::OPC_Decode, 221, 4, 38, // Opcode: SUBC8mi
/* 207 */     MCD::OPC_FilterValue, 8, 47, 0, // Skip to: 258
/* 211 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 214 */     MCD::OPC_FilterValue, 9, 4, 0, // Skip to: 222
/* 218 */     MCD::OPC_Decode, 186, 4, 37, // Opcode: SUB16mm
/* 222 */     MCD::OPC_FilterValue, 11, 10, 0, // Skip to: 236
/* 226 */     MCD::OPC_CheckField, 8, 4, 0, 127, 1, // Skip to: 615
/* 232 */     MCD::OPC_Decode, 185, 4, 38, // Opcode: SUB16mi
/* 236 */     MCD::OPC_FilterValue, 13, 4, 0, // Skip to: 244
/* 240 */     MCD::OPC_Decode, 198, 4, 37, // Opcode: SUB8mm
/* 244 */     MCD::OPC_FilterValue, 15, 111, 1, // Skip to: 615
/* 248 */     MCD::OPC_CheckField, 8, 4, 0, 105, 1, // Skip to: 615
/* 254 */     MCD::OPC_Decode, 197, 4, 38, // Opcode: SUB8mi
/* 258 */     MCD::OPC_FilterValue, 9, 47, 0, // Skip to: 309
/* 262 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 265 */     MCD::OPC_FilterValue, 9, 4, 0, // Skip to: 273
/* 269 */     MCD::OPC_Decode, 211, 3, 37, // Opcode: CMP16mm
/* 273 */     MCD::OPC_FilterValue, 11, 10, 0, // Skip to: 287
/* 277 */     MCD::OPC_CheckField, 8, 4, 0, 76, 1, // Skip to: 615
/* 283 */     MCD::OPC_Decode, 210, 3, 38, // Opcode: CMP16mi
/* 287 */     MCD::OPC_FilterValue, 13, 4, 0, // Skip to: 295
/* 291 */     MCD::OPC_Decode, 223, 3, 37, // Opcode: CMP8mm
/* 295 */     MCD::OPC_FilterValue, 15, 60, 1, // Skip to: 615
/* 299 */     MCD::OPC_CheckField, 8, 4, 0, 54, 1, // Skip to: 615
/* 305 */     MCD::OPC_Decode, 222, 3, 38, // Opcode: CMP8mi
/* 309 */     MCD::OPC_FilterValue, 10, 47, 0, // Skip to: 360
/* 313 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 316 */     MCD::OPC_FilterValue, 9, 4, 0, // Skip to: 324
/* 320 */     MCD::OPC_Decode, 235, 3, 37, // Opcode: DADD16mm
/* 324 */     MCD::OPC_FilterValue, 11, 10, 0, // Skip to: 338
/* 328 */     MCD::OPC_CheckField, 8, 4, 0, 25, 1, // Skip to: 615
/* 334 */     MCD::OPC_Decode, 234, 3, 38, // Opcode: DADD16mi
/* 338 */     MCD::OPC_FilterValue, 13, 4, 0, // Skip to: 346
/* 342 */     MCD::OPC_Decode, 247, 3, 37, // Opcode: DADD8mm
/* 346 */     MCD::OPC_FilterValue, 15, 9, 1, // Skip to: 615
/* 350 */     MCD::OPC_CheckField, 8, 4, 0, 3, 1, // Skip to: 615
/* 356 */     MCD::OPC_Decode, 246, 3, 38, // Opcode: DADD8mi
/* 360 */     MCD::OPC_FilterValue, 11, 47, 0, // Skip to: 411
/* 364 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 367 */     MCD::OPC_FilterValue, 9, 4, 0, // Skip to: 375
/* 371 */     MCD::OPC_Decode, 179, 3, 37, // Opcode: BIT16mm
/* 375 */     MCD::OPC_FilterValue, 11, 10, 0, // Skip to: 389
/* 379 */     MCD::OPC_CheckField, 8, 4, 0, 230, 0, // Skip to: 615
/* 385 */     MCD::OPC_Decode, 178, 3, 38, // Opcode: BIT16mi
/* 389 */     MCD::OPC_FilterValue, 13, 4, 0, // Skip to: 397
/* 393 */     MCD::OPC_Decode, 191, 3, 37, // Opcode: BIT8mm
/* 397 */     MCD::OPC_FilterValue, 15, 214, 0, // Skip to: 615
/* 401 */     MCD::OPC_CheckField, 8, 4, 0, 208, 0, // Skip to: 615
/* 407 */     MCD::OPC_Decode, 190, 3, 38, // Opcode: BIT8mi
/* 411 */     MCD::OPC_FilterValue, 12, 47, 0, // Skip to: 462
/* 415 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 418 */     MCD::OPC_FilterValue, 9, 4, 0, // Skip to: 426
/* 422 */     MCD::OPC_Decode, 131, 3, 37, // Opcode: BIC16mm
/* 426 */     MCD::OPC_FilterValue, 11, 10, 0, // Skip to: 440
/* 430 */     MCD::OPC_CheckField, 8, 4, 0, 179, 0, // Skip to: 615
/* 436 */     MCD::OPC_Decode, 130, 3, 38, // Opcode: BIC16mi
/* 440 */     MCD::OPC_FilterValue, 13, 4, 0, // Skip to: 448
/* 444 */     MCD::OPC_Decode, 143, 3, 37, // Opcode: BIC8mm
/* 448 */     MCD::OPC_FilterValue, 15, 163, 0, // Skip to: 615
/* 452 */     MCD::OPC_CheckField, 8, 4, 0, 157, 0, // Skip to: 615
/* 458 */     MCD::OPC_Decode, 142, 3, 38, // Opcode: BIC8mi
/* 462 */     MCD::OPC_FilterValue, 13, 47, 0, // Skip to: 513
/* 466 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 469 */     MCD::OPC_FilterValue, 9, 4, 0, // Skip to: 477
/* 473 */     MCD::OPC_Decode, 155, 3, 37, // Opcode: BIS16mm
/* 477 */     MCD::OPC_FilterValue, 11, 10, 0, // Skip to: 491
/* 481 */     MCD::OPC_CheckField, 8, 4, 0, 128, 0, // Skip to: 615
/* 487 */     MCD::OPC_Decode, 154, 3, 38, // Opcode: BIS16mi
/* 491 */     MCD::OPC_FilterValue, 13, 4, 0, // Skip to: 499
/* 495 */     MCD::OPC_Decode, 167, 3, 37, // Opcode: BIS8mm
/* 499 */     MCD::OPC_FilterValue, 15, 112, 0, // Skip to: 615
/* 503 */     MCD::OPC_CheckField, 8, 4, 0, 106, 0, // Skip to: 615
/* 509 */     MCD::OPC_Decode, 166, 3, 38, // Opcode: BIS8mi
/* 513 */     MCD::OPC_FilterValue, 14, 47, 0, // Skip to: 564
/* 517 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 520 */     MCD::OPC_FilterValue, 9, 4, 0, // Skip to: 528
/* 524 */     MCD::OPC_Decode, 246, 4, 37, // Opcode: XOR16mm
/* 528 */     MCD::OPC_FilterValue, 11, 10, 0, // Skip to: 542
/* 532 */     MCD::OPC_CheckField, 8, 4, 0, 77, 0, // Skip to: 615
/* 538 */     MCD::OPC_Decode, 245, 4, 38, // Opcode: XOR16mi
/* 542 */     MCD::OPC_FilterValue, 13, 4, 0, // Skip to: 550
/* 546 */     MCD::OPC_Decode, 130, 5, 37, // Opcode: XOR8mm
/* 550 */     MCD::OPC_FilterValue, 15, 61, 0, // Skip to: 615
/* 554 */     MCD::OPC_CheckField, 8, 4, 0, 55, 0, // Skip to: 615
/* 560 */     MCD::OPC_Decode, 129, 5, 38, // Opcode: XOR8mi
/* 564 */     MCD::OPC_FilterValue, 15, 47, 0, // Skip to: 615
/* 568 */     MCD::OPC_ExtractField, 4, 4,  // Inst{7-4} ...
/* 571 */     MCD::OPC_FilterValue, 9, 4, 0, // Skip to: 579
/* 575 */     MCD::OPC_Decode, 235, 2, 37, // Opcode: AND16mm
/* 579 */     MCD::OPC_FilterValue, 11, 10, 0, // Skip to: 593
/* 583 */     MCD::OPC_CheckField, 8, 4, 0, 26, 0, // Skip to: 615
/* 589 */     MCD::OPC_Decode, 234, 2, 38, // Opcode: AND16mi
/* 593 */     MCD::OPC_FilterValue, 13, 4, 0, // Skip to: 601
/* 597 */     MCD::OPC_Decode, 247, 2, 37, // Opcode: AND8mm
/* 601 */     MCD::OPC_FilterValue, 15, 10, 0, // Skip to: 615
/* 605 */     MCD::OPC_CheckField, 8, 4, 0, 4, 0, // Skip to: 615
/* 611 */     MCD::OPC_Decode, 246, 2, 38, // Opcode: AND8mi
/* 615 */     MCD::OPC_Fail,
  0
};

static bool checkDecoderPredicate(unsigned Idx, const FeatureBitset &Bits) {
  llvm_unreachable("Invalid index!");
}

template <typename InsnType>
static DecodeStatus decodeToMCInst(DecodeStatus S, unsigned Idx, InsnType insn, MCInst &MI,
                                   uint64_t Address, const MCDisassembler *Decoder, bool &DecodeComplete) {
  DecodeComplete = true;
  using TmpType = std::conditional_t<std::is_integral<InsnType>::value, InsnType, uint64_t>;
  TmpType tmp;
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 1:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 2:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 3:
    tmp = fieldFromInstruction(insn, 0, 6);
    if (!Check(S, DecodeCGImm(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 4:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 5:
    return S;
  case 6:
    tmp = fieldFromInstruction(insn, 0, 10);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 7:
    tmp = fieldFromInstruction(insn, 0, 10);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 8:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 4), 0, 4);
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 4, 16);
    if (!Check(S, DecodeMemOperand(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 9:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 10:
    tmp = fieldFromInstruction(insn, 8, 4);
    if (!Check(S, DecodeGR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 11:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 8, 4);
    if (!Check(S, DecodeGR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 12:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 8, 4);
    if (!Check(S, DecodeGR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 13:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 8, 4);
    if (!Check(S, DecodeGR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 14:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 8, 4);
    if (!Check(S, DecodeGR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 15:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 4), 0, 4);
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 4, 16);
    if (!Check(S, DecodeMemOperand(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 8, 4);
    if (!Check(S, DecodeGR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 16:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 4), 0, 4);
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 4, 16);
    if (!Check(S, DecodeMemOperand(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 8, 4);
    if (!Check(S, DecodeGR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 17:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 4, 2), 4, 2);
    insertBits(tmp, fieldFromInstruction(insn, 8, 4), 0, 4);
    if (!Check(S, DecodeCGImm(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 18:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 4, 2), 4, 2);
    insertBits(tmp, fieldFromInstruction(insn, 8, 4), 0, 4);
    if (!Check(S, DecodeCGImm(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 19:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 4, 2), 4, 2);
    insertBits(tmp, fieldFromInstruction(insn, 8, 4), 0, 4);
    if (!Check(S, DecodeCGImm(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 20:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 4, 2), 4, 2);
    insertBits(tmp, fieldFromInstruction(insn, 8, 4), 0, 4);
    if (!Check(S, DecodeCGImm(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 21:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 4), 0, 4);
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 4, 16);
    if (!Check(S, DecodeMemOperand(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 4, 2), 4, 2);
    insertBits(tmp, fieldFromInstruction(insn, 8, 4), 0, 4);
    if (!Check(S, DecodeCGImm(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 22:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 8, 4);
    if (!Check(S, DecodeGR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 8, 4);
    if (!Check(S, DecodeGR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 23:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 8, 4);
    if (!Check(S, DecodeGR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 24:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 8, 4);
    if (!Check(S, DecodeGR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 8, 4);
    if (!Check(S, DecodeGR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 25:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 8, 4);
    if (!Check(S, DecodeGR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 8, 4);
    if (!Check(S, DecodeGR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 26:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 8, 4);
    if (!Check(S, DecodeGR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 27:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 8, 4);
    if (!Check(S, DecodeGR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 8, 4);
    if (!Check(S, DecodeGR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 28:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 8, 4), 0, 4);
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 4, 16);
    if (!Check(S, DecodeMemOperand(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 29:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 8, 4), 0, 4);
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 4, 16);
    if (!Check(S, DecodeMemOperand(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 30:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 31:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 8, 4), 0, 4);
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 4, 16);
    if (!Check(S, DecodeMemOperand(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 32:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 33:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 8, 4), 0, 4);
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 4, 16);
    if (!Check(S, DecodeMemOperand(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 34:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 35:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 8, 4), 0, 4);
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 4, 16);
    if (!Check(S, DecodeMemOperand(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 36:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeGR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 37:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 4), 0, 4);
    insertBits(tmp, fieldFromInstruction(insn, 32, 16), 4, 16);
    if (!Check(S, DecodeMemOperand(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 8, 4), 0, 4);
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 4, 16);
    if (!Check(S, DecodeMemOperand(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 38:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 4), 0, 4);
    insertBits(tmp, fieldFromInstruction(insn, 32, 16), 4, 16);
    if (!Check(S, DecodeMemOperand(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  }
}

static unsigned decodeNumToSkip(const uint8_t *&Ptr) {
  unsigned NumToSkip = *Ptr++;
  NumToSkip |= (*Ptr++) << 8;
  return NumToSkip;
}

template <typename InsnType>
static DecodeStatus decodeInstruction(const uint8_t DecodeTable[], MCInst &MI,
                                      InsnType insn, uint64_t Address,
                                      const MCDisassembler *DisAsm,
                                      const MCSubtargetInfo &STI) {
  const FeatureBitset &Bits = STI.getFeatureBits();

  const uint8_t *Ptr = DecodeTable;
  uint64_t CurFieldValue = 0;
  DecodeStatus S = MCDisassembler::Success;
  while (true) {
    ptrdiff_t Loc = Ptr - DecodeTable;
    switch (*Ptr++) {
    default:
      errs() << Loc << ": Unexpected decode table opcode!\n";
      return MCDisassembler::Fail;
    case MCD::OPC_ExtractField: {
      // Decode the start value.
      unsigned Start = decodeULEB128AndIncUnsafe(Ptr);
      unsigned Len = *Ptr++;
      CurFieldValue = fieldFromInstruction(insn, Start, Len);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_ExtractField(" << Start << ", "
                   << Len << "): " << CurFieldValue << "\n");
      break;
    }
    case MCD::OPC_FilterValue: {
      // Decode the field value.
      uint64_t Val = decodeULEB128AndIncUnsafe(Ptr);
      bool Failed = Val != CurFieldValue;
      unsigned NumToSkip = decodeNumToSkip(Ptr);

      // Perform the filter operation.
      if (Failed)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_FilterValue(" << Val << ", " << NumToSkip
                   << "): " << (Failed ? "FAIL:" : "PASS:")
                   << " continuing at " << (Ptr - DecodeTable) << "\n");

      break;
    }
    case MCD::OPC_CheckField: {
      // Decode the start value.
      unsigned Start = decodeULEB128AndIncUnsafe(Ptr);
      unsigned Len = *Ptr;
      uint64_t FieldValue = fieldFromInstruction(insn, Start, Len);
      // Decode the field value.
      unsigned PtrLen = 0;
      uint64_t ExpectedValue = decodeULEB128(++Ptr, &PtrLen);
      Ptr += PtrLen;
      bool Failed = ExpectedValue != FieldValue;
      unsigned NumToSkip = decodeNumToSkip(Ptr);

      // If the actual and expected values don't match, skip.
      if (Failed)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckField(" << Start << ", "
                   << Len << ", " << ExpectedValue << ", " << NumToSkip
                   << "): FieldValue = " << FieldValue << ", ExpectedValue = "
                   << ExpectedValue << ": "
                   << (Failed ? "FAIL\n" : "PASS\n"));
      break;
    }
    case MCD::OPC_CheckPredicate: {
      // Decode the Predicate Index value.
      unsigned PIdx = decodeULEB128AndIncUnsafe(Ptr);
      unsigned NumToSkip = decodeNumToSkip(Ptr);
      // Check the predicate.
      bool Failed = !checkDecoderPredicate(PIdx, Bits);
      if (Failed)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckPredicate(" << PIdx << "): "
            << (Failed ? "FAIL\n" : "PASS\n"));

      break;
    }
    case MCD::OPC_Decode: {
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128AndIncUnsafe(Ptr);
      unsigned DecodeIdx = decodeULEB128AndIncUnsafe(Ptr);

      MI.clear();
      MI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, MI, Address, DisAsm, DecodeComplete);
      assert(DecodeComplete);

      LLVM_DEBUG(dbgs() << Loc << ": OPC_Decode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": "
                   << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
      return S;
    }
    case MCD::OPC_TryDecode: {
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128AndIncUnsafe(Ptr);
      unsigned DecodeIdx = decodeULEB128AndIncUnsafe(Ptr);
      unsigned NumToSkip = decodeNumToSkip(Ptr);

      // Perform the decode operation.
      MCInst TmpMI;
      TmpMI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, TmpMI, Address, DisAsm, DecodeComplete);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_TryDecode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": ");

      if (DecodeComplete) {
        // Decoding complete.
        LLVM_DEBUG(dbgs() << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
        MI = TmpMI;
        return S;
      } else {
        assert(S == MCDisassembler::Fail);
        // If the decoding was incomplete, skip.
        Ptr += NumToSkip;
        LLVM_DEBUG(dbgs() << "FAIL: continuing at " << (Ptr - DecodeTable) << "\n");
        // Reset decode status. This also drops a SoftFail status that could be
        // set before the decode attempt.
        S = MCDisassembler::Success;
      }
      break;
    }
    case MCD::OPC_SoftFail: {
      // Decode the mask values.
      uint64_t PositiveMask = decodeULEB128AndIncUnsafe(Ptr);
      uint64_t NegativeMask = decodeULEB128AndIncUnsafe(Ptr);
      bool Fail = (insn & PositiveMask) != 0 || (~insn & NegativeMask) != 0;
      if (Fail)
        S = MCDisassembler::SoftFail;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_SoftFail: " << (Fail ? "FAIL\n" : "PASS\n"));
      break;
    }
    case MCD::OPC_Fail: {
      LLVM_DEBUG(dbgs() << Loc << ": OPC_Fail\n");
      return MCDisassembler::Fail;
    }
    }
  }
  llvm_unreachable("bogosity detected in disassembler state machine!");
}


} // namespace
